Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jmx.export.assembler
Class MethodExclusionMBeanInfoAssembler

    java.lang.Object
      org.springframework.jmx.export.assembler.AbstractMBeanInfoAssembler
          org.springframework.jmx.export.assembler.AbstractReflectiveMBeanInfoAssembler
              org.springframework.jmx.export.assembler.AbstractConfigurableMBeanInfoAssembler
                  org.springframework.jmx.export.assembler.MethodExclusionMBeanInfoAssembler

All Implemented Interfaces:
  MBeanInfoAssembler

    public class MethodExclusionMBeanInfoAssembler

extends AbstractConfigurableMBeanInfoAssembler

`AbstractReflectiveMBeanInfoAssembler` subclass that allows method names to be explicitly excluded as MBean operations and attributes.

Any method not explicitly excluded from the management interface will be exposed to JMX. JavaBean getters and setters will automatically be exposed as JMX attributes.

You can supply an array of method names via the `ignoredMethods` property. If you have multiple beans and you wish each bean to use a different set of method names, then you can map bean keys (that is the name used to pass the bean to the `MBeanExporter`) to a list of method names using the `ignoredMethodMappings` property.

If you specify values for both `ignoredMethodMappings` and `ignoredMethods`, Spring will attempt to find method names in the mappings first. If no method names for the bean are found, it will use the method names defined by `ignoredMethods`.

Since:
  1.2.5
Author:
  Rob Harrop, Seth Ladd
See Also:
  `setIgnoredMethods(java.lang.String[])`, `setIgnoredMethodMappings(java.util.Properties)`, `InterfaceBasedMBeanInfoAssembler`, `SimpleReflectiveMBeanInfoAssembler`, `MethodNameBasedMBeanInfoAssembler`, `MBeanExporter`

Field Summary

Fields inherited from class org.springframework.jmx.export.assembler.AbstractReflectiveMBeanInfoAssembler
`ATTRIBUTE_OPERATION_VISIBILITY, FIELD_CLASS, FIELD_CURRENCY_TIME_LIMIT, FIELD_DEFAULT, FIELD_DISPLAY_NAME, FIELD_GET_METHOD, FIELD_LOG, FIELD_LOG_FILE, FIELD_METRIC_CATEGORY, FIELD_METRIC_TYPE, FIELD_PERSIST_LOCATION, FIELD_PERSIST_NAME, FIELD_PERSIST_PERIOD, FIELD_PERSIST_POLICY, FIELD_ROLE, FIELD_SET_METHOD, FIELD_UNITS, FIELD_VISIBILITY, ROLE_GETTER, ROLE_OPERATION, ROLE_SETTER`

Constructor Summary
`MethodExclusionMBeanInfoAssembler()`

Method Summary
`protected boolean` | `includeOperation(java.lang.reflect.Method method, java.lang.String beanKey)` Allows subclasses to vote on the inclusion of a particular operation.
`protected boolean` | `includeReadAttribute(java.lang.reflect.Method method, java.lang.String beanKey)` Allows subclasses to vote on the inclusion of a particular attribute accessor.
`protected boolean` | `includeWriteAttribute(java.lang.reflect.Method method, java.lang.String beanKey)` Allows subclasses to vote on the inclusion of a particular attribute mutator.
`protected boolean` | `isNotIgnored(java.lang.reflect.Method method, java.lang.String beanKey)` Determine whether the given method is supposed to be included, that is, not configured as to be ignored.
`void` | `setIgnoredMethodMappings(java.util.Properties mappings)` Set the mappings of bean keys to a comma-separated list of method names.
`void` | `setIgnoredMethods(java.lang.String[] ignoredMethodNames)` Set the array of method names to be ignored when creating the management info.

Methods inherited from class org.springframework.jmx.export.assembler.AbstractConfigurableMBeanInfoAssembler
`getNotificationInfo, setNotificationInfoMappings, setNotificationInfos`

Methods inherited from class org.springframework.jmx.export.assembler.AbstractReflectiveMBeanInfoAssembler
`applyCurrencyTimeLimit, applyDefaultCurrencyTimeLimit, createModelMBeanOperationInfo, getAttributeDescription, getAttributeInfo, getClassForDescriptor, getDefaultCurrencyTimeLimit, getOperationDescription, getOperationInfo, getOperationParameters, isExposeClassDescriptor, isUseStrictCasing, populateAttributeDescriptor, populateMBeanDescriptor, populateOperationDescriptor, setDefaultCurrencyTimeLimit, setExposeClassDescriptor, setUseStrictCasing`

Methods inherited from class org.springframework.jmx.export.assembler.AbstractMBeanInfoAssembler
`checkManagedBean, getClassName, getClassToExpose, getClassToExpose, getConstructorInfo, getDescription, getMBeanInfo, getTargetClass`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MethodExclusionMBeanInfoAssembler

    public MethodExclusionMBeanInfoAssembler()

Method Detail

### setIgnoredMethods

    public void setIgnoredMethods(java.lang.String[] ignoredMethodNames)

  Set the array of method names to be ignored when creating the management info.

  These method names will be used for a bean if no entry corresponding to that bean is found in the `ignoredMethodsMappings` property.

  See Also:
    `setIgnoredMethodMappings(java.util.Properties)`

### setIgnoredMethodMappings

    public void setIgnoredMethodMappings(java.util.Properties mappings)

  Set the mappings of bean keys to a comma-separated list of method names.

  These method names are ignored when creating the management interface.

  The property key must match the bean key and the property value must match the list of method names. When searching for method names to ignore for a bean, Spring will check these mappings first.

### includeReadAttribute

    protected boolean includeReadAttribute(java.lang.reflect.Method method,
                                           java.lang.String beanKey)

  Description copied from class: `AbstractReflectiveMBeanInfoAssembler`
  Allows subclasses to vote on the inclusion of a particular attribute accessor.

  Specified by:
    `includeReadAttribute` in class `AbstractReflectiveMBeanInfoAssembler`
  Parameters:
    `method` - the accessor `Method`
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    `true` if the accessor should be included in the management interface, otherwise `false```

### includeWriteAttribute

    protected boolean includeWriteAttribute(java.lang.reflect.Method method,
                                            java.lang.String beanKey)

  Description copied from class: `AbstractReflectiveMBeanInfoAssembler`
  Allows subclasses to vote on the inclusion of a particular attribute mutator.

  Specified by:
    `includeWriteAttribute` in class `AbstractReflectiveMBeanInfoAssembler`
  Parameters:
    `method` - the mutator `Method`.
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    `true` if the mutator should be included in the management interface, otherwise `false```

### includeOperation

    protected boolean includeOperation(java.lang.reflect.Method method,
                                       java.lang.String beanKey)

  Description copied from class: `AbstractReflectiveMBeanInfoAssembler`
  Allows subclasses to vote on the inclusion of a particular operation.

  Specified by:
    `includeOperation` in class `AbstractReflectiveMBeanInfoAssembler`
  Parameters:
    `method` - the operation method
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`
  Returns:
    whether the operation should be included in the management interface

### isNotIgnored

    protected boolean isNotIgnored(java.lang.reflect.Method method,
                                   java.lang.String beanKey)

  Determine whether the given method is supposed to be included, that is, not configured as to be ignored.

  Parameters:
    `method` - the operation method
    `beanKey` - the key associated with the MBean in the beans map of the `MBeanExporter`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD